unit math3d;

interface

type TVector3f = record
  X, Y, Z : single;
end;

type TVector3i = record
  X, Y, Z : integer;
end;

type TVector3b = record
  R, G, B : byte;
end;

type TVector3b2 = record
  X, Y, Z : byte;
end;

type TVector3si = record
  X, Y, Z : smallint;
end;

type TVector3l = record
  X, Y, Z : longword;
end;

type TVector2f = record
  X, Y : single;
end;

type TVector2i = record
  X, Y : Integer;
end;

Type TVector4f = record
  X, Y, Z, Alpha : single;
end;

  PSmallIntArray = ^TSmallIntArray;
  TSmallIntArray = array[0..MAXINT shr 2] of SmallInt;

  PCardinalArray = ^TCardinalArray;
  TCardinalArray = array[0..MAXINT shr 3] of Cardinal;

// TGLPixel32
   //
   TGLPixel32 = packed record
      r, g, b, a : Byte;
   end;

   PGLPixel32Array = ^TGLPixel32Array;
   TGLPixel32Array = array of TGLPixel32;

   // General arrays
   PByteArray = ^TByteArray;
   TByteArray = array[0..32767] of Byte;

const
  M_PI = 3.1415926535897932384626433832795;		// matches value in gcc v2 math.h
  M_TWO_PI = 6.283185307179586476925286766559;
  M_180_PI = 57.295779513082320876798154814105;
  M_PI_180 = 0.017453292519943295769236907684886;

Function SetVector(X,Y,Z : Single) : TVector3f;

implementation

Function SetVector(X,Y,Z : Single) : TVector3f;
begin

Result.X := X;
Result.Y := Y;
Result.Z := Z;

end;

end.
